﻿/*
*	FILE			: DeviceControl.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0.0
*	DATE            : March 20, 2019
*	DESCRIPTION 	: Used for manage Fitness data and encryption
*/

using System;

namespace MiBand_Heartrate
{
    internal class DeviceControl
    {
        #region DeviceControl_Singleton

        private static readonly DeviceControl instance = new DeviceControl();

        static DeviceControl()
        {
        }

        private DeviceControl()
        {
        }

        public static DeviceControl Instance => instance;

        #endregion DeviceControl_Singleton

        private BLEManager bluetoothManager = null;

        public BLEManager BluetoothManager => bluetoothManager;

        public void Initialize()
        {
            bluetoothManager = new BLEManager();
        }

        public void WriteRealtimeHeartrateInFile(MiBand d, ushort v)
        {
            BBMiBandDataEncryption.EncryptData(v.ToString() + "," + DateTime.Now.ToString("HH:mm:ss") + "," + DateTime.Now.ToString("yyyy-MM-dd"));
        }
    }
}