USE [master]
GO

/****** Object:  Database [BBData] ******/
CREATE DATABASE [BBData]

USE [BBData]
GO

/****** Object:  Table [dbo].[BBThermostatData] ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[BBThermostatData](
	[tHumidity] [float] NOT NULL,
	[tTemperature] [float] NOT NULL,
	[tT_heat] [float](50) NOT NULL,
	[tT_cool] [float](50) NOT NULL,
	[tTmode] [varchar](50) NOT NULL,
	[tFmode] [varchar](50) NOT NULL,
	[tHold] [varchar](50) NOT NULL,
	[tTstate] [varchar](50) NOT NULL,
	[tTtarget] [varchar](50) NOT NULL,
	[tProgramMode] [varchar](50) NOT NULL,
	[tFstate] [varchar](50) NOT NULL,
	[tTime] [varchar](50) NULL,
	[tDate] [date] NOT NULL
) ON [PRIMARY]

GO

USE [BBData]
GO

/****** Object:  Table [dbo].[BBPresenseSensorsData]  ******/
SET ANSI_NULLS ON
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE TABLE [dbo].[BBPresenseSensorsData](
	[pLocation] [varchar](50) NOT NULL,
	[pStatus] [varchar](50) NOT NULL,
	[pTemperature] [float] NOT NULL,
	[pHumidity] [float] NOT NULL,
	[pTime] [varchar](50) NOT NULL,
	[pDate] [datetime] NOT NULL
) ON [PRIMARY]

GO
