﻿/*
*	FILE			: BBSensorDataDecrytion.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0.0
*	DATE            : March 20, 2019
*	DESCRIPTION 	: This file manages the decryption of the collected data.
*/

using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace BBSensorDataEncryptor
{
    public class BBSensorDataDecryption
    {
        #region Variables

        private static string pSensor = "";
        private static string SensorKey = BBSensorDataEncrypDecrypKey.sKey();
        private static string SensorIV = BBSensorDataEncrypDecrypKey.sIV();
        private static byte[] SensorIVByte = { };
        private static byte[] SensorKeyByte = { };
        private static byte[] inputByteArray;
        private static MemoryStream ms = null;
        private static CryptoStream cs = null;

        #endregion Variables

        #region Data Decryption

        /// <summary>
        /// This method decrypt the sensor data
        /// </summary>
        /// <param name="SensorData"></param>
        /// <returns></returns>
        public static string DecryptData(string SensorData)
        {
            SensorIVByte = Encoding.UTF8.GetBytes(SensorIV.Substring(0, 8));
            SensorKeyByte = Encoding.UTF8.GetBytes(SensorKey.Substring(0, 8));

            inputByteArray = new byte[SensorData.Replace(" ", "+").Length];
            inputByteArray = Convert.FromBase64String(SensorData.Replace(" ", "+"));
            using (DESCryptoServiceProvider des = new DESCryptoServiceProvider())
            {
                ms = new MemoryStream();
                cs = new CryptoStream(ms, des.CreateDecryptor(SensorKeyByte, SensorIVByte), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                Encoding encoding = Encoding.UTF8;
                pSensor = encoding.GetString(ms.ToArray());
            }

            return pSensor;
        }

        #endregion Data Decryption
    }
}