﻿/*
*	FILE			: BBSensorDataEncryption.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0.0
*	DATE            : March 20, 2019
*	DESCRIPTION 	: This file manages the data encryption of the collected data.
*/

using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace BBSensorDataEncryptor
{
    public class BBSensorDataEncryption
    {
        private static string pSensor = "";
        private static string SensorKey = BBSensorDataEncrypDecrypKey.sKey();
        private static string SensorIV = BBSensorDataEncrypDecrypKey.sIV();
        private static byte[] SensorIVByte = { };
        private static byte[] SensorKeyByte = { };
        private static byte[] inputByteArray;
        private static MemoryStream ms = null;
        private static CryptoStream cs = null;
        private static readonly string dataPath = @"BBPS\presenceData.xml";

        /// <summary>
        /// This method encrypts the sensor data
        /// </summary>
        /// <param name="SensorData"></param>
        /// <returns></returns>
        public static void EncryptData(string SensorData)
        {
            SensorIVByte = Encoding.UTF8.GetBytes(SensorIV.Substring(0, 8));
            SensorKeyByte = Encoding.UTF8.GetBytes(SensorKey.Substring(0, 8));

            inputByteArray = Encoding.UTF8.GetBytes(SensorData);
            using (DESCryptoServiceProvider des = new DESCryptoServiceProvider())
            {
                ms = new MemoryStream();
                cs = new CryptoStream(ms, des.CreateEncryptor(SensorKeyByte, SensorIVByte), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                pSensor = Convert.ToBase64String(ms.ToArray());
            }
            // Save encrypted data to a file
            SaveSensorData();
        }

        /// <summary>
        /// Store encrypted sensor data
        /// </summary>
        /// <param name="= SaveSensorData"></param>

        private static void SaveSensorData()
        {
            if (!File.Exists(dataPath))
            {
                File.WriteAllText(dataPath, pSensor + Environment.NewLine);
            }

            File.AppendAllText(dataPath, pSensor + Environment.NewLine);
        }
    }
}