﻿/*
*	FILE			: BBSensorErrorLogs.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0.0
*	DATE            : March 20, 2019
*	DESCRIPTION 	: This file manages the data logging of all errors.
*/

using System;
using System.IO;

namespace BBSensorsErrorLog
{
    public class BBSensorErrorLog
    {
        private static readonly string dataPath = @"BBEL\sensorErrorLog.txt";

        /// <summary>
        /// Log all the error that occurs in the program
        /// </summary>
        /// <param name="error"></param>
        public static void SaveErrorData(string error)
        {
            if (!File.Exists(dataPath))
            {
                File.WriteAllText(dataPath, error + DateTime.Now.ToString("HH:mm:ss") + "," + DateTime.Now.ToString("yyyy-MM-dd") + Environment.NewLine);
            }

            File.AppendAllText(dataPath, error + DateTime.Now.ToString("HH:mm:ss") + "," + DateTime.Now.ToString("yyyy-MM-dd") + Environment.NewLine);
        }
    }
}