﻿/*
*	FILE			: BBthermostatConnect.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	DATE            : March 20, 2019
*	FIRST VERSION	: 1.0.0.0
*	DESCRIPTION 	: This library file manage the connection protocol for the thermostat.
*/

using BBSensorsErrorLog;
using BBTaskerThermostatStatus;
using System.IO;
using System.Net;

namespace BBThermostatConnection
{
    public class BBThermostatConnect
    {
        /// <summary>
        /// </summary>
        public enum BBThermostatProtocol
        {
            GET
        }

        /// <summary>
        /// </summary>
        private static BBThermostatProtocol BBThermostatMethod { get; set; }

        /// <summary>
        /// </summary>
        public static string results;

        /// <summary>
        /// this method retrieve the full status of the thermostat
        /// </summary>
        /// <returns></returns>
        public static string BBThermostatRequestA()
        {
            BBThermostatMethod = BBThermostatProtocol.GET;

            HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://192.168.137.18/tstat/");

            request.Method = BBThermostatMethod.ToString();

            using (HttpWebResponse response = (HttpWebResponse)request.GetResponse())
            {
                // Set operation status to true
                BBThermostatStatus.SensorStatus(true);

                if (response.StatusCode != HttpStatusCode.OK)
                {
                    BBSensorErrorLog.SaveErrorData("Thermostat unable to get request from 192.168.137.18//tstat//");
                    // Set operation status to false
                    BBThermostatStatus.SensorStatus(false);
                }

                using (Stream BBThermostatRequestStream = response.GetResponseStream())
                {
                    if (BBThermostatRequestStream != null)
                    {
                        using (StreamReader reader = new StreamReader(BBThermostatRequestStream))
                        {
                            results = reader.ReadToEnd();
                        }
                    }
                }
            }

            return results;
        }

        /// <summary>
        /// this method retrieve the humidity from the thermostat
        /// </summary>
        /// <returns></returns>
        public static string BBThermostatRequestB()
        {
            BBThermostatMethod = BBThermostatProtocol.GET;

            HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://192.168.137.18/tstat/humidity");
            request.Method = BBThermostatMethod.ToString();

            using (HttpWebResponse response = (HttpWebResponse)request.GetResponse())
            {
                // Set operation status to true
                BBThermostatStatus.SensorStatus(true);

                if (response.StatusCode != HttpStatusCode.OK)
                {
                    BBSensorErrorLog.SaveErrorData("Thermostat unable to get request from 192.168.137.18//humidity//");

                    // Set operation status to true
                    BBThermostatStatus.SensorStatus(false);
                }

                using (Stream BBThermostatRequestStream = response.GetResponseStream())
                {
                    if (BBThermostatRequestStream != null)
                    {
                        using (StreamReader reader = new StreamReader(BBThermostatRequestStream))
                        {
                            results = reader.ReadToEnd();
                        }
                    }
                }
            }

            return results;
        }

        /// <summary>
        /// This method retrieve thermostat model
        /// </summary>
        /// <returns></returns>
        public static string BBThermostatType()
        {
            BBThermostatMethod = BBThermostatProtocol.GET;

            HttpWebRequest request = (HttpWebRequest)WebRequest.Create("http://192.168.137.18/tstat/model");
            request.Method = BBThermostatMethod.ToString();

            using (HttpWebResponse response = (HttpWebResponse)request.GetResponse())
            {
                // Set operation status to true
                BBThermostatStatus.SensorStatus(true);

                if (response.StatusCode != HttpStatusCode.OK)
                {
                    BBSensorErrorLog.SaveErrorData("Thermostat unable to get request from 192.168.137.18//tstat//model");
                    // Set operation status to false
                    BBThermostatStatus.SensorStatus(false);
                }

                using (Stream BBThermostatRequestStream = response.GetResponseStream())
                {
                    if (BBThermostatRequestStream != null)
                    {
                        using (StreamReader reader = new StreamReader(BBThermostatRequestStream))
                        {
                            results = reader.ReadToEnd();
                        }
                    }
                }
            }

            return results;
        }
    }
}