﻿/*
*	FILE			: BBthermostatDataEncryption.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0.0
*	DESCRIPTION 	: This library file manage the encryption of the  thermostat data.
*/

using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;

namespace BBThermostatDataEncryptor
{
    public class BBThermostatDataEncryption
    {
        /// <summary>
        /// thermostat encryption variables
        /// </summary>
        private static string pSensor = "";

        private static string SensorKey = BBThermostatDataEncypDecrypKey.sKey();
        private static string SensorIV = BBThermostatDataEncypDecrypKey.sIV();
        private static byte[] SensorIVByte = { };
        private static byte[] SensorKeyByte = { };
        private static byte[] inputByteArray;
        private static MemoryStream ms = null;
        private static CryptoStream cs = null;
        private static readonly string dataPath = @"BBTS\thermostatData.xml";

        /// <summary>
        /// This method encrypts the thermostat data
        /// </summary>
        /// <param name="SensorData"></param>
        /// <returns></returns>
        public static void EncryptData(string SensorData)
        {
            SensorIVByte = Encoding.UTF8.GetBytes(SensorIV.Substring(0, 8));
            SensorKeyByte = Encoding.UTF8.GetBytes(SensorKey.Substring(0, 8));

            inputByteArray = Encoding.UTF8.GetBytes(SensorData + "," + DateTime.Now.ToString(" h:mm:ss tt") + "," + DateTime.Now.ToString("yyyy-MM-dd"));
            using (DESCryptoServiceProvider des = new DESCryptoServiceProvider())
            {
                ms = new MemoryStream();
                cs = new CryptoStream(ms, des.CreateEncryptor(SensorKeyByte, SensorIVByte), CryptoStreamMode.Write);
                cs.Write(inputByteArray, 0, inputByteArray.Length);
                cs.FlushFinalBlock();
                pSensor = Convert.ToBase64String(ms.ToArray());
            }
            // Save encrypted data  to a file
            SaveSensorData();
        }

        /// <summary>
        /// Store encrypted sensor data to a file
        /// </summary>
        private static void SaveSensorData()
        {
            if (!File.Exists(dataPath))
            {
                File.WriteAllText(dataPath, pSensor + Environment.NewLine);
            }

            File.AppendAllText(dataPath, pSensor + Environment.NewLine);
        }
    }
}