﻿/*
*	FILE			: program.cs
*	PROJECT			: Black Box
*	PROGRAMMER		: BRIAN HINDS
*	FIRST VERSION	: 1.0.0.0
*	DESCRIPTION 	: This file is the main program for the BBThermostatSensor.
*/

using BBThermostatDataEncryptor;
using System.Threading;

/*
 *
 * Thermostat Architecture
 *
 *
Conestoga College

Copyright (c) 2019, Brian Hinds

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sub-license, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.
*/

namespace BBThermostatSensor
{
    internal class Program
    {
        private const int timerInerval = 60000;

        /// <summary>
        /// This method executes the thermostat data request on 10 sec interval
        /// </summary>
        /// <param name="stateInfo"></param>
        public static void Tick(object stateInfo)
        {
            BBThermostatDataRequest.BBThermosataCheck();
        }

        /// <summary>
        /// this is the main method for the BBthermostatSensor
        /// </summary>
        /// <param name="args"></param>
        private static void Main(string[] args)
        {
            TimerCallback callback = new TimerCallback(Tick);

            // create a one second timer tick
            System.Threading.Timer stateTimer = new System.Threading.Timer(callback, null, 0, timerInerval);

            // loop here forever
            for (; ; )
            {
                // add a sleep for 100 mSec to reduce CPU usage
                Thread.Sleep(100);
            }
        }
    }
}